#include "mysqlcppapi/datetime/DateTime.h"
#include <iomanip>

namespace mysqlcppapi
{

DateTime::DateTime()
{
}

DateTime::~DateTime()
{
}


std::ostream& DateTime::out_stream(std::ostream& s) const
{
  date_base::out_stream(s);
  s << " ";
  time_base::out_stream(s);
  return s;
}


std::string::size_type DateTime::convert(const std::string& str)
{
  std::string::size_type iResult = date_base::convert(str);
  
  if (str.at(iResult) == ' ')
    iResult++;
    
  iResult = time_base::convert(str.substr(iResult));
  
  return iResult;
}


short int DateTime::compare(const DateTime& other) const
{
  int x;
  x = date_base::compare(&other);
  
  if (x)
    return x;
    
  return time_base::compare(&other);
}

} //namespace


