#include "mysqlcppapi/exceptions/ex_BadConversion.h"

namespace mysqlcppapi
{

ex_BadConversion::ex_BadConversion() throw()
: ex_base("Bad Conversion")
{
	m_sizeRetrieved = 0;
	m_sizeActual = 0;
}

ex_BadConversion::ex_BadConversion(const std::string& strTypeName, const std::string& strData, size_t sizeRetrieved, size_t sizeActual) throw()
: ex_base("Bad Conversion")
{
  m_strTypeName = strTypeName;
  m_strData = strData;
  m_sizeRetrieved = sizeRetrieved;
  m_sizeActual = sizeActual;
}

ex_BadConversion::ex_BadConversion(const ex_BadConversion& src) throw()
: ex_base(src)
{
	operator=(src);
}

ex_BadConversion& ex_BadConversion::operator=(const ex_BadConversion& src)
{
	ex_base::operator=(src);

	m_strTypeName = src.m_strTypeName;
	m_strData = src.m_strData;
	m_sizeRetrieved = src.m_sizeRetrieved;
	m_sizeActual = src.m_sizeActual;
	
	return *this;
}

ex_BadConversion::~ex_BadConversion() throw()
{
}
  
size_t ex_BadConversion::get_SizeRetrieved() const
{
  return m_sizeRetrieved;
}

std::string ex_BadConversion::get_TypeName() const
{
  return m_strTypeName;
}
  
std::string ex_BadConversion::get_Data() const
{
  return m_strData;
}

size_t ex_BadConversion::get_SizeActual() const
{
  return m_sizeActual;
}

} //namespace
