#include "mysqlcppapi/fields/Fields.h"
#include "mysqlcppapi/query_results/Result_Use.h"
//#include "mysqlcppapi/Connection.h"

namespace mysqlcppapi
{

Fields::Fields()
{
}

Fields::Fields(MYSQL_RES* pResult, bool bFullFieldInfo /* = false */)
{ 
  if(pResult)
  {
    size_type num = mysql_num_fields(pResult);
    
    for(size_type i = 0; i < num; i++)
    {
      ::mysql_field_seek (pResult, i);

      MYSQL_FIELD* pMysqlField = ::mysql_fetch_field(pResult);
      if(pMysqlField)
      {
        FieldInfo fieldInfo(*pMysqlField, bFullFieldInfo);
        push_back(fieldInfo);
      }
    }
  }
}

Fields::Fields(const Fields& src)
: type_base(src)
{
}

Fields::~Fields()
{
}

Fields& Fields::operator=(const Fields& src)
{
  type_base::operator=(src);

  return *this;
}

const FieldInfo& Fields::operator [] (size_type i) const
{
  return type_base::operator[](i);
}

const FieldInfo& Fields::operator [] (const std::string& strFieldName) const
{
  return operator[](get_index(strFieldName));
}
  

Fields::size_type Fields::get_index(const std::string& strFieldName) const
{ 
  //string temp(strFieldName);
  //str_to_lwr(temp);

  FieldInfo result;
  
  for(size_type i = 0; i < size(); i++)
  {
    const FieldInfo& fieldInfo = operator[](i);
    if(fieldInfo.get_Name() == strFieldName)
      return i;
  }

  throw ex_base("field name not found: " + strFieldName);
  return 0;
}

bool Fields::get_PrimaryKey(size_type& i) const
{
  //Initialize output args:
  i = 0;
  
  for(size_type index = 0; i < size(); i++)
  {
    const FieldInfo& fieldInfo = operator[](i);
    if(fieldInfo.get_IsPrimaryKey())
    {
      i = index;
      return true; //Found.
    }
  }

  return false; //Not found.
}
 

} //namespace
